<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>Leader.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.quorum</a> &gt; <span class="el_source">Leader.java</span></div><h1>Leader.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.quorum;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.net.BindException;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketAddress;
import java.net.SocketException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.concurrent.atomic.AtomicLong;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ConcurrentLinkedQueue;
import java.util.concurrent.ConcurrentMap;

import org.apache.jute.BinaryOutputArchive;
import org.apache.zookeeper.server.FinalRequestProcessor;
import org.apache.zookeeper.server.Request;
import org.apache.zookeeper.server.RequestProcessor;
import org.apache.zookeeper.server.ZooKeeperThread;
import org.apache.zookeeper.server.quorum.QuorumPeer.LearnerType;
import org.apache.zookeeper.server.quorum.flexible.QuorumVerifier;
import org.apache.zookeeper.server.util.ZxidUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * This class has the control logic for the Leader.
 */
public class Leader {
<span class="fc" id="L55">    private static final Logger LOG = LoggerFactory.getLogger(Leader.class);</span>
    
<span class="fc" id="L57">    static final private boolean nodelay = System.getProperty(&quot;leader.nodelay&quot;, &quot;true&quot;).equals(&quot;true&quot;);</span>
    static {
<span class="fc" id="L59">        LOG.info(&quot;TCP NoDelay set to: &quot; + nodelay);</span>
<span class="fc" id="L60">    }</span>

<span class="fc" id="L62">    static public class Proposal {</span>
        public QuorumPacket packet;

<span class="fc" id="L65">        public HashSet&lt;Long&gt; ackSet = new HashSet&lt;Long&gt;();</span>

        public Request request;

        @Override
        public String toString() {
<span class="nc" id="L71">            return packet.getType() + &quot;, &quot; + packet.getZxid() + &quot;, &quot; + request;</span>
        }
    }

    final LeaderZooKeeperServer zk;

    final QuorumPeer self;

<span class="fc" id="L79">    private boolean quorumFormed = false;</span>
    
    // the follower acceptor thread
    LearnerCnxAcceptor cnxAcceptor;
    
    // list of all the followers
<span class="fc" id="L85">    private final HashSet&lt;LearnerHandler&gt; learners =</span>
        new HashSet&lt;LearnerHandler&gt;();

    /**
     * Returns a copy of the current learner snapshot
     */
    public List&lt;LearnerHandler&gt; getLearners() {
<span class="fc" id="L92">        synchronized (learners) {</span>
<span class="fc" id="L93">            return new ArrayList&lt;LearnerHandler&gt;(learners);</span>
<span class="nc" id="L94">        }</span>
    }

    // list of followers that are ready to follow (i.e synced with the leader)
<span class="fc" id="L98">    private final HashSet&lt;LearnerHandler&gt; forwardingFollowers =</span>
        new HashSet&lt;LearnerHandler&gt;();
    
    /**
     * Returns a copy of the current forwarding follower snapshot
     */
    public List&lt;LearnerHandler&gt; getForwardingFollowers() {
<span class="fc" id="L105">        synchronized (forwardingFollowers) {</span>
<span class="fc" id="L106">            return new ArrayList&lt;LearnerHandler&gt;(forwardingFollowers);</span>
<span class="nc" id="L107">        }</span>
    }

    private void addForwardingFollower(LearnerHandler lh) {
<span class="fc" id="L111">        synchronized (forwardingFollowers) {</span>
<span class="fc" id="L112">            forwardingFollowers.add(lh);</span>
<span class="pc" id="L113">        }</span>
<span class="fc" id="L114">    }</span>

<span class="fc" id="L116">    private final HashSet&lt;LearnerHandler&gt; observingLearners =</span>
        new HashSet&lt;LearnerHandler&gt;();
        
    /**
     * Returns a copy of the current observer snapshot
     */
    public List&lt;LearnerHandler&gt; getObservingLearners() {
<span class="fc" id="L123">        synchronized (observingLearners) {</span>
<span class="fc" id="L124">            return new ArrayList&lt;LearnerHandler&gt;(observingLearners);</span>
<span class="nc" id="L125">        }</span>
    }

    private void addObserverLearnerHandler(LearnerHandler lh) {
<span class="fc" id="L129">        synchronized (observingLearners) {</span>
<span class="fc" id="L130">            observingLearners.add(lh);</span>
<span class="pc" id="L131">        }</span>
<span class="fc" id="L132">    }</span>

    // Pending sync requests. Must access under 'this' lock.
<span class="fc" id="L135">    private final HashMap&lt;Long,List&lt;LearnerSyncRequest&gt;&gt; pendingSyncs =</span>
        new HashMap&lt;Long,List&lt;LearnerSyncRequest&gt;&gt;();
    
    synchronized public int getNumPendingSyncs() {
<span class="fc" id="L139">        return pendingSyncs.size();</span>
    }

    //Follower counter
<span class="fc" id="L143">    final AtomicLong followerCounter = new AtomicLong(-1);</span>

    /**
     * Adds peer to the leader.
     * 
     * @param learner
     *                instance of learner handle
     */
    void addLearnerHandler(LearnerHandler learner) {
<span class="fc" id="L152">        synchronized (learners) {</span>
<span class="fc" id="L153">            learners.add(learner);</span>
<span class="pc" id="L154">        }</span>
<span class="fc" id="L155">    }</span>

    /**
     * Remove the learner from the learner list
     * 
     * @param peer
     */
    void removeLearnerHandler(LearnerHandler peer) {
<span class="fc" id="L163">        synchronized (forwardingFollowers) {</span>
<span class="fc" id="L164">            forwardingFollowers.remove(peer);            </span>
<span class="pc" id="L165">        }        </span>
<span class="fc" id="L166">        synchronized (learners) {</span>
<span class="fc" id="L167">            learners.remove(peer);</span>
<span class="pc" id="L168">        }</span>
<span class="fc" id="L169">        synchronized (observingLearners) {</span>
<span class="fc" id="L170">            observingLearners.remove(peer);</span>
<span class="pc" id="L171">        }</span>
<span class="fc" id="L172">    }</span>

    boolean isLearnerSynced(LearnerHandler peer){
<span class="nc" id="L175">        synchronized (forwardingFollowers) {</span>
<span class="nc" id="L176">            return forwardingFollowers.contains(peer);</span>
<span class="nc" id="L177">        }        </span>
    }
    
    ServerSocket ss;

<span class="fc" id="L182">    Leader(QuorumPeer self,LeaderZooKeeperServer zk) throws IOException {</span>
<span class="fc" id="L183">        this.self = self;</span>
        try {
<span class="pc bpc" id="L185" title="1 of 2 branches missed.">            if (self.getQuorumListenOnAllIPs()) {</span>
<span class="nc" id="L186">                ss = new ServerSocket(self.getQuorumAddress().getPort());</span>
            } else {
<span class="fc" id="L188">                ss = new ServerSocket();</span>
            }
<span class="fc" id="L190">            ss.setReuseAddress(true);</span>
<span class="pc bpc" id="L191" title="1 of 2 branches missed.">            if (!self.getQuorumListenOnAllIPs()) {</span>
<span class="fc" id="L192">                ss.bind(self.getQuorumAddress());</span>
            }
<span class="nc" id="L194">        } catch (BindException e) {</span>
<span class="nc bnc" id="L195" title="All 2 branches missed.">            if (self.getQuorumListenOnAllIPs()) {</span>
<span class="nc" id="L196">                LOG.error(&quot;Couldn't bind to port &quot; + self.getQuorumAddress().getPort(), e);</span>
            } else {
<span class="nc" id="L198">                LOG.error(&quot;Couldn't bind to &quot; + self.getQuorumAddress(), e);</span>
            }
<span class="nc" id="L200">            throw e;</span>
<span class="fc" id="L201">        }</span>
<span class="fc" id="L202">        this.zk=zk;</span>
<span class="fc" id="L203">    }</span>

    /**
     * This message is for follower to expect diff
     */
    final static int DIFF = 13;
    
    /**
     * This is for follower to truncate its logs 
     */
    final static int TRUNC = 14;
    
    /**
     * This is for follower to download the snapshots
     */
    final static int SNAP = 15;
    
    /**
     * This tells the leader that the connecting peer is actually an observer
     */
    final static int OBSERVERINFO = 16;
    
    /**
     * This message type is sent by the leader to indicate it's zxid and if
     * needed, its database.
     */
    final static int NEWLEADER = 10;

    /**
     * This message type is sent by a follower to pass the last zxid. This is here
     * for backward compatibility purposes.
     */
    final static int FOLLOWERINFO = 11;

    /**
     * This message type is sent by the leader to indicate that the follower is
     * now uptodate andt can start responding to clients.
     */
    final static int UPTODATE = 12;

    /**
     * This message is the first that a follower receives from the leader.
     * It has the protocol version and the epoch of the leader.
     */
    public static final int LEADERINFO = 17;

    /**
     * This message is used by the follow to ack a proposed epoch.
     */
    public static final int ACKEPOCH = 18;
    
    /**
     * This message type is sent to a leader to request and mutation operation.
     * The payload will consist of a request header followed by a request.
     */
    final static int REQUEST = 1;

    /**
     * This message type is sent by a leader to propose a mutation.
     */
    public final static int PROPOSAL = 2;

    /**
     * This message type is sent by a follower after it has synced a proposal.
     */
    final static int ACK = 3;

    /**
     * This message type is sent by a leader to commit a proposal and cause
     * followers to start serving the corresponding data.
     */
    final static int COMMIT = 4;

    /**
     * This message type is enchanged between follower and leader (initiated by
     * follower) to determine liveliness.
     */
    final static int PING = 5;

    /**
     * This message type is to validate a session that should be active.
     */
    final static int REVALIDATE = 6;

    /**
     * This message is a reply to a synchronize command flushing the pipe
     * between the leader and the follower.
     */
    final static int SYNC = 7;
        
    /**
     * This message type informs observers of a committed proposal.
     */
    final static int INFORM = 8;

<span class="fc" id="L298">    ConcurrentMap&lt;Long, Proposal&gt; outstandingProposals = new ConcurrentHashMap&lt;Long, Proposal&gt;();</span>

<span class="fc" id="L300">    ConcurrentLinkedQueue&lt;Proposal&gt; toBeApplied = new ConcurrentLinkedQueue&lt;Proposal&gt;();</span>

<span class="fc" id="L302">    Proposal newLeaderProposal = new Proposal();</span>
    
    class LearnerCnxAcceptor extends ZooKeeperThread{
<span class="fc" id="L305">        private volatile boolean stop = false;</span>

<span class="fc" id="L307">        public LearnerCnxAcceptor() {</span>
<span class="fc" id="L308">            super(&quot;LearnerCnxAcceptor-&quot; + ss.getLocalSocketAddress());</span>
<span class="fc" id="L309">        }</span>

        @Override
        public void run() {
            try {
<span class="fc bfc" id="L314" title="All 2 branches covered.">                while (!stop) {</span>
                    try{
<span class="fc" id="L316">                        Socket s = ss.accept();</span>
                        // start with the initLimit, once the ack is processed
                        // in LearnerHandler switch to the syncLimit
<span class="fc" id="L319">                        s.setSoTimeout(self.tickTime * self.initLimit);</span>
<span class="fc" id="L320">                        s.setTcpNoDelay(nodelay);</span>
<span class="fc" id="L321">                        LearnerHandler fh = new LearnerHandler(s, Leader.this);</span>
<span class="fc" id="L322">                        fh.start();</span>
<span class="fc" id="L323">                    } catch (SocketException e) {</span>
<span class="pc bpc" id="L324" title="1 of 2 branches missed.">                        if (stop) {</span>
<span class="fc" id="L325">                            LOG.info(&quot;exception while shutting down acceptor: &quot;</span>
                                    + e);

                            // When Leader.shutdown() calls ss.close(),
                            // the call to accept throws an exception.
                            // We catch and set stop to true.
<span class="fc" id="L331">                            stop = true;</span>
                        } else {
<span class="nc" id="L333">                            throw e;</span>
                        }
<span class="fc" id="L335">                    }</span>
                }
<span class="nc" id="L337">            } catch (Exception e) {</span>
<span class="nc" id="L338">                LOG.warn(&quot;Exception while accepting follower&quot;, e);</span>
<span class="fc" id="L339">            }</span>
<span class="fc" id="L340">        }</span>
        
        public void halt() {
<span class="fc" id="L343">            stop = true;</span>
<span class="fc" id="L344">        }</span>
    }

    StateSummary leaderStateSummary;
    
<span class="fc" id="L349">    long epoch = -1;</span>
<span class="fc" id="L350">    boolean waitingForNewEpoch = true;</span>
<span class="fc" id="L351">    volatile boolean readyToStart = false;</span>
    
    /**
     * This method is main function that is called to lead
     * 
     * @throws IOException
     * @throws InterruptedException
     */
    void lead() throws IOException, InterruptedException {
<span class="fc" id="L360">        self.end_fle = System.currentTimeMillis();</span>
<span class="fc" id="L361">        LOG.info(&quot;LEADING - LEADER ELECTION TOOK - &quot; +</span>
              (self.end_fle - self.start_fle));
<span class="fc" id="L363">        self.start_fle = 0;</span>
<span class="fc" id="L364">        self.end_fle = 0;</span>

<span class="fc" id="L366">        zk.registerJMX(new LeaderBean(this, zk), self.jmxLocalPeerBean);</span>

        try {
<span class="fc" id="L369">            self.tick = 0;</span>
<span class="fc" id="L370">            zk.loadData();</span>
            
<span class="fc" id="L372">            leaderStateSummary = new StateSummary(self.getCurrentEpoch(), zk.getLastProcessedZxid());</span>

            // Start thread that waits for connection requests from 
            // new followers.
<span class="fc" id="L376">            cnxAcceptor = new LearnerCnxAcceptor();</span>
<span class="fc" id="L377">            cnxAcceptor.start();</span>
            
<span class="fc" id="L379">            readyToStart = true;</span>
<span class="fc" id="L380">            long epoch = getEpochToPropose(self.getId(), self.getAcceptedEpoch());</span>
            
<span class="fc" id="L382">            zk.setZxid(ZxidUtils.makeZxid(epoch, 0));</span>
            
<span class="fc" id="L384">            synchronized(this){</span>
<span class="fc" id="L385">                lastProposed = zk.getZxid();</span>
<span class="pc" id="L386">            }</span>
            
<span class="fc" id="L388">            newLeaderProposal.packet = new QuorumPacket(NEWLEADER, zk.getZxid(),</span>
                    null, null);


<span class="pc bpc" id="L392" title="1 of 2 branches missed.">            if ((newLeaderProposal.packet.getZxid() &amp; 0xffffffffL) != 0) {</span>
<span class="nc" id="L393">                LOG.info(&quot;NEWLEADER proposal has Zxid of &quot;</span>
<span class="nc" id="L394">                        + Long.toHexString(newLeaderProposal.packet.getZxid()));</span>
            }
            
<span class="fc" id="L397">            waitForEpochAck(self.getId(), leaderStateSummary);</span>
<span class="fc" id="L398">            self.setCurrentEpoch(epoch);</span>

            // We have to get at least a majority of servers in sync with
            // us. We do this by waiting for the NEWLEADER packet to get
            // acknowledged
            try {
<span class="fc" id="L404">                waitForNewLeaderAck(self.getId(), zk.getZxid(), LearnerType.PARTICIPANT);</span>
<span class="fc" id="L405">            } catch (InterruptedException e) {</span>
<span class="fc" id="L406">                shutdown(&quot;Waiting for a quorum of followers, only synced with sids: [ &quot;</span>
<span class="fc" id="L407">                        + getSidSetString(newLeaderProposal.ackSet) + &quot; ]&quot;);</span>
<span class="fc" id="L408">                HashSet&lt;Long&gt; followerSet = new HashSet&lt;Long&gt;();</span>
<span class="pc bpc" id="L409" title="1 of 2 branches missed.">                for (LearnerHandler f : learners)</span>
<span class="nc" id="L410">                    followerSet.add(f.getSid());</span>
                    
<span class="pc bpc" id="L412" title="1 of 2 branches missed.">                if (self.getQuorumVerifier().containsQuorum(followerSet)) {</span>
<span class="nc" id="L413">                    LOG.warn(&quot;Enough followers present. &quot;</span>
                            + &quot;Perhaps the initTicks need to be increased.&quot;);
                }
<span class="fc" id="L416">                Thread.sleep(self.tickTime);</span>
<span class="fc" id="L417">                self.tick++;</span>
<span class="fc" id="L418">                return;</span>
<span class="fc" id="L419">            }</span>
            
<span class="fc" id="L421">            startZkServer();</span>
            
            /**
             * WARNING: do not use this for anything other than QA testing
             * on a real cluster. Specifically to enable verification that quorum
             * can handle the lower 32bit roll-over issue identified in
             * ZOOKEEPER-1277. Without this option it would take a very long
             * time (on order of a month say) to see the 4 billion writes
             * necessary to cause the roll-over to occur.
             * 
             * This field allows you to override the zxid of the server. Typically
             * you'll want to set it to something like 0xfffffff0 and then
             * start the quorum, run some operations and see the re-election.
             */
<span class="fc" id="L435">            String initialZxid = System.getProperty(&quot;zookeeper.testingonly.initialZxid&quot;);</span>
<span class="pc bpc" id="L436" title="1 of 2 branches missed.">            if (initialZxid != null) {</span>
<span class="nc" id="L437">                long zxid = Long.parseLong(initialZxid);</span>
<span class="nc" id="L438">                zk.setZxid((zk.getZxid() &amp; 0xffffffff00000000L) | zxid);</span>
            }
            
<span class="pc bpc" id="L441" title="1 of 2 branches missed.">            if (!System.getProperty(&quot;zookeeper.leaderServes&quot;, &quot;yes&quot;).equals(&quot;no&quot;)) {</span>
<span class="fc" id="L442">                self.cnxnFactory.setZooKeeperServer(zk);</span>
            }
            // Everything is a go, simply start counting the ticks
            // WARNING: I couldn't find any wait statement on a synchronized
            // block that would be notified by this notifyAll() call, so
            // I commented it out
            //synchronized (this) {
            //    notifyAll();
            //}
            // We ping twice a tick, so we only update the tick every other
            // iteration
<span class="fc" id="L453">            boolean tickSkip = true;</span>
    
            while (true) {
<span class="fc" id="L456">                Thread.sleep(self.tickTime / 2);</span>
<span class="fc bfc" id="L457" title="All 2 branches covered.">                if (!tickSkip) {</span>
<span class="fc" id="L458">                    self.tick++;</span>
                }
<span class="fc" id="L460">                HashSet&lt;Long&gt; syncedSet = new HashSet&lt;Long&gt;();</span>

                // lock on the followers when we use it.
<span class="fc" id="L463">                syncedSet.add(self.getId());</span>

<span class="fc bfc" id="L465" title="All 2 branches covered.">                for (LearnerHandler f : getLearners()) {</span>
                    // Synced set is used to check we have a supporting quorum, so only
                    // PARTICIPANT, not OBSERVER, learners should be used
<span class="fc bfc" id="L468" title="All 4 branches covered.">                    if (f.synced() &amp;&amp; f.getLearnerType() == LearnerType.PARTICIPANT) {</span>
<span class="fc" id="L469">                        syncedSet.add(f.getSid());</span>
                    }
<span class="fc" id="L471">                    f.ping();</span>
<span class="fc" id="L472">                }</span>

<span class="fc bfc" id="L474" title="All 4 branches covered.">              if (!tickSkip &amp;&amp; !self.getQuorumVerifier().containsQuorum(syncedSet)) {</span>
                //if (!tickSkip &amp;&amp; syncedCount &lt; self.quorumPeers.size() / 2) {
                    // Lost quorum, shutdown
<span class="fc" id="L477">                    shutdown(&quot;Not sufficient followers synced, only synced with sids: [ &quot;</span>
<span class="fc" id="L478">                            + getSidSetString(syncedSet) + &quot; ]&quot;);</span>
                    // make sure the order is the same!
                    // the leader goes to looking
<span class="fc" id="L481">                    return;</span>
              } 
<span class="fc bfc" id="L483" title="All 2 branches covered.">              tickSkip = !tickSkip;</span>
<span class="fc" id="L484">            }</span>
        } finally {
<span class="fc" id="L486">            zk.unregisterJMX(this);</span>
        }
    }

    boolean isShutdown;

    /**
     * Close down all the LearnerHandlers
     */
    void shutdown(String reason) {
<span class="fc" id="L496">        LOG.info(&quot;Shutting down&quot;);</span>

<span class="fc bfc" id="L498" title="All 2 branches covered.">        if (isShutdown) {</span>
<span class="fc" id="L499">            return;</span>
        }
        
<span class="fc" id="L502">        LOG.info(&quot;Shutdown called&quot;,</span>
                new Exception(&quot;shutdown Leader! reason: &quot; + reason));

<span class="fc bfc" id="L505" title="All 2 branches covered.">        if (cnxAcceptor != null) {</span>
<span class="fc" id="L506">            cnxAcceptor.halt();</span>
        }
        
        // NIO should not accept conenctions
<span class="fc" id="L510">        self.cnxnFactory.setZooKeeperServer(null);</span>
        try {
<span class="fc" id="L512">            ss.close();</span>
<span class="nc" id="L513">        } catch (IOException e) {</span>
<span class="nc" id="L514">            LOG.warn(&quot;Ignoring unexpected exception during close&quot;,e);</span>
<span class="fc" id="L515">        }</span>
        // clear all the connections
<span class="fc" id="L517">        self.cnxnFactory.closeAll();</span>
        // shutdown the previous zk
<span class="pc bpc" id="L519" title="1 of 2 branches missed.">        if (zk != null) {</span>
<span class="fc" id="L520">            zk.shutdown();</span>
        }
<span class="fc" id="L522">        synchronized (learners) {</span>
<span class="fc" id="L523">            for (Iterator&lt;LearnerHandler&gt; it = learners.iterator(); it</span>
<span class="fc bfc" id="L524" title="All 2 branches covered.">                    .hasNext();) {</span>
<span class="fc" id="L525">                LearnerHandler f = it.next();</span>
<span class="fc" id="L526">                it.remove();</span>
<span class="fc" id="L527">                f.shutdown();</span>
<span class="fc" id="L528">            }</span>
<span class="pc" id="L529">        }</span>
<span class="fc" id="L530">        isShutdown = true;</span>
<span class="fc" id="L531">    }</span>

    /**
     * Keep a count of acks that are received by the leader for a particular
     * proposal
     * 
     * @param zxid
     *                the zxid of the proposal sent out
     * @param followerAddr
     */
    synchronized public void processAck(long sid, long zxid, SocketAddress followerAddr) {
<span class="pc bpc" id="L542" title="1 of 2 branches missed.">        if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L543">            LOG.trace(&quot;Ack zxid: 0x{}&quot;, Long.toHexString(zxid));</span>
<span class="nc bnc" id="L544" title="All 2 branches missed.">            for (Proposal p : outstandingProposals.values()) {</span>
<span class="nc" id="L545">                long packetZxid = p.packet.getZxid();</span>
<span class="nc" id="L546">                LOG.trace(&quot;outstanding proposal: 0x{}&quot;,</span>
<span class="nc" id="L547">                        Long.toHexString(packetZxid));</span>
<span class="nc" id="L548">            }</span>
<span class="nc" id="L549">            LOG.trace(&quot;outstanding proposals all&quot;);</span>
        }

<span class="fc bfc" id="L552" title="All 2 branches covered.">        if ((zxid &amp; 0xffffffffL) == 0) {</span>
            /*
             * We no longer process NEWLEADER ack by this method. However,
             * the learner sends ack back to the leader after it gets UPTODATE
             * so we just ignore the message.
             */
<span class="fc" id="L558">            return;</span>
        }
    
<span class="fc bfc" id="L561" title="All 2 branches covered.">        if (outstandingProposals.size() == 0) {</span>
<span class="pc bpc" id="L562" title="1 of 2 branches missed.">            if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L563">                LOG.debug(&quot;outstanding is 0&quot;);</span>
            }
<span class="fc" id="L565">            return;</span>
        }
<span class="fc bfc" id="L567" title="All 2 branches covered.">        if (lastCommitted &gt;= zxid) {</span>
<span class="pc bpc" id="L568" title="1 of 2 branches missed.">            if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L569">                LOG.debug(&quot;proposal has already been committed, pzxid: 0x{} zxid: 0x{}&quot;,</span>
<span class="nc" id="L570">                        Long.toHexString(lastCommitted), Long.toHexString(zxid));</span>
            }
            // The proposal has already been committed
<span class="fc" id="L573">            return;</span>
        }
<span class="fc" id="L575">        Proposal p = outstandingProposals.get(zxid);</span>
<span class="pc bpc" id="L576" title="1 of 2 branches missed.">        if (p == null) {</span>
<span class="nc" id="L577">            LOG.warn(&quot;Trying to commit future proposal: zxid 0x{} from {}&quot;,</span>
<span class="nc" id="L578">                    Long.toHexString(zxid), followerAddr);</span>
<span class="nc" id="L579">            return;</span>
        }
        
<span class="fc" id="L582">        p.ackSet.add(sid);</span>
<span class="pc bpc" id="L583" title="1 of 2 branches missed.">        if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L584">            LOG.debug(&quot;Count for zxid: 0x{} is {}&quot;,</span>
<span class="nc" id="L585">                    Long.toHexString(zxid), p.ackSet.size());</span>
        }
<span class="fc bfc" id="L587" title="All 2 branches covered.">        if (self.getQuorumVerifier().containsQuorum(p.ackSet)){             </span>
<span class="fc bfc" id="L588" title="All 2 branches covered.">            if (zxid != lastCommitted+1) {</span>
<span class="fc" id="L589">                LOG.warn(&quot;Commiting zxid 0x{} from {} not first!&quot;,</span>
<span class="fc" id="L590">                        Long.toHexString(zxid), followerAddr);</span>
<span class="fc" id="L591">                LOG.warn(&quot;First is 0x{}&quot;, Long.toHexString(lastCommitted + 1));</span>
            }
<span class="fc" id="L593">            outstandingProposals.remove(zxid);</span>
<span class="pc bpc" id="L594" title="1 of 2 branches missed.">            if (p.request != null) {</span>
<span class="fc" id="L595">                toBeApplied.add(p);</span>
            }

<span class="pc bpc" id="L598" title="1 of 2 branches missed.">            if (p.request == null) {</span>
<span class="nc" id="L599">                LOG.warn(&quot;Going to commmit null request for proposal: {}&quot;, p);</span>
            }
<span class="fc" id="L601">            commit(zxid);</span>
<span class="fc" id="L602">            inform(p);</span>
<span class="fc" id="L603">            zk.commitProcessor.commit(p.request);</span>
<span class="pc bpc" id="L604" title="1 of 2 branches missed.">            if(pendingSyncs.containsKey(zxid)){</span>
<span class="nc bnc" id="L605" title="All 2 branches missed.">                for(LearnerSyncRequest r: pendingSyncs.remove(zxid)) {</span>
<span class="nc" id="L606">                    sendSync(r);</span>
<span class="nc" id="L607">                }</span>
            }
        }
<span class="fc" id="L610">    }</span>

    static class ToBeAppliedRequestProcessor implements RequestProcessor {
        private RequestProcessor next;

        private ConcurrentLinkedQueue&lt;Proposal&gt; toBeApplied;

        /**
         * This request processor simply maintains the toBeApplied list. For
         * this to work next must be a FinalRequestProcessor and
         * FinalRequestProcessor.processRequest MUST process the request
         * synchronously!
         * 
         * @param next
         *                a reference to the FinalRequestProcessor
         */
        ToBeAppliedRequestProcessor(RequestProcessor next,
<span class="fc" id="L627">                ConcurrentLinkedQueue&lt;Proposal&gt; toBeApplied) {</span>
<span class="pc bpc" id="L628" title="1 of 2 branches missed.">            if (!(next instanceof FinalRequestProcessor)) {</span>
<span class="nc" id="L629">                throw new RuntimeException(ToBeAppliedRequestProcessor.class</span>
<span class="nc" id="L630">                        .getName()</span>
                        + &quot; must be connected to &quot;
<span class="nc" id="L632">                        + FinalRequestProcessor.class.getName()</span>
                        + &quot; not &quot;
<span class="nc" id="L634">                        + next.getClass().getName());</span>
            }
<span class="fc" id="L636">            this.toBeApplied = toBeApplied;</span>
<span class="fc" id="L637">            this.next = next;</span>
<span class="fc" id="L638">        }</span>

        /*
         * (non-Javadoc)
         * 
         * @see org.apache.zookeeper.server.RequestProcessor#processRequest(org.apache.zookeeper.server.Request)
         */
        public void processRequest(Request request) throws RequestProcessorException {
            // request.addRQRec(&quot;&gt;tobe&quot;);
<span class="fc" id="L647">            next.processRequest(request);</span>
<span class="fc" id="L648">            Proposal p = toBeApplied.peek();</span>
<span class="pc bpc" id="L649" title="2 of 6 branches missed.">            if (p != null &amp;&amp; p.request != null</span>
                    &amp;&amp; p.request.zxid == request.zxid) {
<span class="fc" id="L651">                toBeApplied.remove();</span>
            }
<span class="fc" id="L653">        }</span>

        /*
         * (non-Javadoc)
         * 
         * @see org.apache.zookeeper.server.RequestProcessor#shutdown()
         */
        public void shutdown() {
<span class="fc" id="L661">            LOG.info(&quot;Shutting down&quot;);</span>
<span class="fc" id="L662">            next.shutdown();</span>
<span class="fc" id="L663">        }</span>
    }

    /**
     * send a packet to all the followers ready to follow
     * 
     * @param qp
     *                the packet to be sent
     */
    void sendPacket(QuorumPacket qp) {
<span class="fc" id="L673">        synchronized (forwardingFollowers) {</span>
<span class="fc bfc" id="L674" title="All 2 branches covered.">            for (LearnerHandler f : forwardingFollowers) {                </span>
<span class="fc" id="L675">                f.queuePacket(qp);</span>
<span class="fc" id="L676">            }</span>
<span class="pc" id="L677">        }</span>
<span class="fc" id="L678">    }</span>
    
    /**
     * send a packet to all observers     
     */
    void sendObserverPacket(QuorumPacket qp) {        
<span class="fc bfc" id="L684" title="All 2 branches covered.">        for (LearnerHandler f : getObservingLearners()) {</span>
<span class="fc" id="L685">            f.queuePacket(qp);</span>
<span class="fc" id="L686">        }</span>
<span class="fc" id="L687">    }</span>

<span class="fc" id="L689">    long lastCommitted = -1;</span>

    /**
     * Create a commit packet and send it to all the members of the quorum
     * 
     * @param zxid
     */
    public void commit(long zxid) {
<span class="fc" id="L697">        synchronized(this){</span>
<span class="fc" id="L698">            lastCommitted = zxid;</span>
<span class="pc" id="L699">        }</span>
<span class="fc" id="L700">        QuorumPacket qp = new QuorumPacket(Leader.COMMIT, zxid, null, null);</span>
<span class="fc" id="L701">        sendPacket(qp);</span>
<span class="fc" id="L702">    }</span>
    
    /**
     * Create an inform packet and send it to all observers.
     * @param zxid
     * @param proposal
     */
    public void inform(Proposal proposal) {   
<span class="fc" id="L710">        QuorumPacket qp = new QuorumPacket(Leader.INFORM, proposal.request.zxid, </span>
<span class="fc" id="L711">                                            proposal.packet.getData(), null);</span>
<span class="fc" id="L712">        sendObserverPacket(qp);</span>
<span class="fc" id="L713">    }</span>

    long lastProposed;

    
    /**
     * Returns the current epoch of the leader.
     * 
     * @return
     */
    public long getEpoch(){
<span class="fc" id="L724">        return ZxidUtils.getEpochFromZxid(lastProposed);</span>
    }
    
    @SuppressWarnings(&quot;serial&quot;)
    public static class XidRolloverException extends Exception {
        public XidRolloverException(String message) {
<span class="fc" id="L730">            super(message);</span>
<span class="fc" id="L731">        }</span>
    }

    /**
     * create a proposal and send it out to all the members
     * 
     * @param request
     * @return the proposal that is queued to send to all the members
     */
    public Proposal propose(Request request) throws XidRolloverException {
        /**
         * Address the rollover issue. All lower 32bits set indicate a new leader
         * election. Force a re-election instead. See ZOOKEEPER-1277
         */
<span class="fc bfc" id="L745" title="All 2 branches covered.">        if ((request.zxid &amp; 0xffffffffL) == 0xffffffffL) {</span>
<span class="fc" id="L746">            String msg =</span>
                    &quot;zxid lower 32 bits have rolled over, forcing re-election, and therefore new epoch start&quot;;
<span class="fc" id="L748">            shutdown(msg);</span>
<span class="fc" id="L749">            throw new XidRolloverException(msg);</span>
        }

<span class="fc" id="L752">        ByteArrayOutputStream baos = new ByteArrayOutputStream();</span>
<span class="fc" id="L753">        BinaryOutputArchive boa = BinaryOutputArchive.getArchive(baos);</span>
        try {
<span class="fc" id="L755">            request.hdr.serialize(boa, &quot;hdr&quot;);</span>
<span class="fc bfc" id="L756" title="All 2 branches covered.">            if (request.txn != null) {</span>
<span class="fc" id="L757">                request.txn.serialize(boa, &quot;txn&quot;);</span>
            }
<span class="fc" id="L759">            baos.close();</span>
<span class="nc" id="L760">        } catch (IOException e) {</span>
<span class="nc" id="L761">            LOG.warn(&quot;This really should be impossible&quot;, e);</span>
<span class="fc" id="L762">        }</span>
<span class="fc" id="L763">        QuorumPacket pp = new QuorumPacket(Leader.PROPOSAL, request.zxid, </span>
<span class="fc" id="L764">                baos.toByteArray(), null);</span>
        
<span class="fc" id="L766">        Proposal p = new Proposal();</span>
<span class="fc" id="L767">        p.packet = pp;</span>
<span class="fc" id="L768">        p.request = request;</span>
<span class="fc" id="L769">        synchronized (this) {</span>
<span class="pc bpc" id="L770" title="1 of 2 branches missed.">            if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L771">                LOG.debug(&quot;Proposing:: &quot; + request);</span>
            }

<span class="fc" id="L774">            lastProposed = p.packet.getZxid();</span>
<span class="fc" id="L775">            outstandingProposals.put(lastProposed, p);</span>
<span class="fc" id="L776">            sendPacket(pp);</span>
<span class="pc" id="L777">        }</span>
<span class="fc" id="L778">        return p;</span>
    }
            
    /**
     * Process sync requests
     * 
     * @param r the request
     */
    
    synchronized public void processSync(LearnerSyncRequest r){
<span class="pc bpc" id="L788" title="1 of 2 branches missed.">        if(outstandingProposals.isEmpty()){</span>
<span class="fc" id="L789">            sendSync(r);</span>
        } else {
<span class="nc" id="L791">            List&lt;LearnerSyncRequest&gt; l = pendingSyncs.get(lastProposed);</span>
<span class="nc bnc" id="L792" title="All 2 branches missed.">            if (l == null) {</span>
<span class="nc" id="L793">                l = new ArrayList&lt;LearnerSyncRequest&gt;();</span>
            }
<span class="nc" id="L795">            l.add(r);</span>
<span class="nc" id="L796">            pendingSyncs.put(lastProposed, l);</span>
        }
<span class="fc" id="L798">    }</span>
        
    /**
     * Sends a sync message to the appropriate server
     * 
     * @param f
     * @param r
     */
            
    public void sendSync(LearnerSyncRequest r){
<span class="fc" id="L808">        QuorumPacket qp = new QuorumPacket(Leader.SYNC, 0, null, null);</span>
<span class="fc" id="L809">        r.fh.queuePacket(qp);</span>
<span class="fc" id="L810">    }</span>
                
    /**
     * lets the leader know that a follower is capable of following and is done
     * syncing
     * 
     * @param handler handler of the follower
     * @return last proposed zxid
     */
    synchronized public long startForwarding(LearnerHandler handler,
            long lastSeenZxid) {
        // Queue up any outstanding requests enabling the receipt of
        // new requests
<span class="fc bfc" id="L823" title="All 2 branches covered.">        if (lastProposed &gt; lastSeenZxid) {</span>
<span class="pc bpc" id="L824" title="1 of 2 branches missed.">            for (Proposal p : toBeApplied) {</span>
<span class="nc bnc" id="L825" title="All 2 branches missed.">                if (p.packet.getZxid() &lt;= lastSeenZxid) {</span>
<span class="nc" id="L826">                    continue;</span>
                }
<span class="nc" id="L828">                handler.queuePacket(p.packet);</span>
                // Since the proposal has been committed we need to send the
                // commit message also
<span class="nc" id="L831">                QuorumPacket qp = new QuorumPacket(Leader.COMMIT, p.packet</span>
<span class="nc" id="L832">                        .getZxid(), null, null);</span>
<span class="nc" id="L833">                handler.queuePacket(qp);</span>
<span class="nc" id="L834">            }</span>
            // Only participant need to get outstanding proposals
<span class="fc bfc" id="L836" title="All 2 branches covered.">            if (handler.getLearnerType() == LearnerType.PARTICIPANT) {</span>
<span class="fc" id="L837">                List&lt;Long&gt;zxids = new ArrayList&lt;Long&gt;(outstandingProposals.keySet());</span>
<span class="fc" id="L838">                Collections.sort(zxids);</span>
<span class="pc bpc" id="L839" title="1 of 2 branches missed.">                for (Long zxid: zxids) {</span>
<span class="nc bnc" id="L840" title="All 2 branches missed.">                    if (zxid &lt;= lastSeenZxid) {</span>
<span class="nc" id="L841">                        continue;</span>
                    }
<span class="nc" id="L843">                    handler.queuePacket(outstandingProposals.get(zxid).packet);</span>
<span class="nc" id="L844">                }</span>
            }
        }
<span class="fc bfc" id="L847" title="All 2 branches covered.">        if (handler.getLearnerType() == LearnerType.PARTICIPANT) {</span>
<span class="fc" id="L848">            addForwardingFollower(handler);</span>
        } else {
<span class="fc" id="L850">            addObserverLearnerHandler(handler);</span>
        }
                
<span class="fc" id="L853">        return lastProposed;</span>
    }

<span class="fc" id="L856">    private HashSet&lt;Long&gt; connectingFollowers = new HashSet&lt;Long&gt;();</span>
    public long getEpochToPropose(long sid, long lastAcceptedEpoch) throws InterruptedException, IOException {
<span class="fc" id="L858">        synchronized(connectingFollowers) {</span>
<span class="fc bfc" id="L859" title="All 2 branches covered.">            if (!waitingForNewEpoch) {</span>
<span class="fc" id="L860">                return epoch;</span>
            }
<span class="fc bfc" id="L862" title="All 2 branches covered.">            if (lastAcceptedEpoch &gt;= epoch) {</span>
<span class="fc" id="L863">                epoch = lastAcceptedEpoch+1;</span>
            }
<span class="fc" id="L865">            connectingFollowers.add(sid);</span>
<span class="fc" id="L866">            QuorumVerifier verifier = self.getQuorumVerifier();</span>
<span class="fc bfc" id="L867" title="All 2 branches covered.">            if (connectingFollowers.contains(self.getId()) &amp;&amp; </span>
<span class="fc bfc" id="L868" title="All 2 branches covered.">                                            verifier.containsQuorum(connectingFollowers)) {</span>
<span class="fc" id="L869">                waitingForNewEpoch = false;</span>
<span class="fc" id="L870">                self.setAcceptedEpoch(epoch);</span>
<span class="fc" id="L871">                connectingFollowers.notifyAll();</span>
            } else {
<span class="fc" id="L873">                long start = System.currentTimeMillis();</span>
<span class="fc" id="L874">                long cur = start;</span>
<span class="fc" id="L875">                long end = start + self.getInitLimit()*self.getTickTime();</span>
<span class="fc bfc" id="L876" title="All 4 branches covered.">                while(waitingForNewEpoch &amp;&amp; cur &lt; end) {</span>
<span class="fc" id="L877">                    connectingFollowers.wait(end - cur);</span>
<span class="fc" id="L878">                    cur = System.currentTimeMillis();</span>
                }
<span class="fc bfc" id="L880" title="All 2 branches covered.">                if (waitingForNewEpoch) {</span>
<span class="fc" id="L881">                    throw new InterruptedException(&quot;Timeout while waiting for epoch from quorum&quot;);        </span>
                }
            }
<span class="fc" id="L884">            return epoch;</span>
<span class="fc" id="L885">        }</span>
    }

<span class="fc" id="L888">    private HashSet&lt;Long&gt; electingFollowers = new HashSet&lt;Long&gt;();</span>
<span class="fc" id="L889">    private boolean electionFinished = false;</span>
    public void waitForEpochAck(long id, StateSummary ss) throws IOException, InterruptedException {
<span class="fc" id="L891">        synchronized(electingFollowers) {</span>
<span class="fc bfc" id="L892" title="All 2 branches covered.">            if (electionFinished) {</span>
<span class="fc" id="L893">                return;</span>
            }
<span class="pc bpc" id="L895" title="1 of 2 branches missed.">            if (ss.getCurrentEpoch() != -1) {</span>
<span class="pc bpc" id="L896" title="1 of 2 branches missed.">                if (ss.isMoreRecentThan(leaderStateSummary)) {</span>
<span class="nc" id="L897">                    throw new IOException(&quot;Follower is ahead of the leader, leader summary: &quot; </span>
<span class="nc" id="L898">                                                    + leaderStateSummary.getCurrentEpoch()</span>
                                                    + &quot; (current epoch), &quot;
<span class="nc" id="L900">                                                    + leaderStateSummary.getLastZxid()</span>
                                                    + &quot; (last zxid)&quot;);
                }
<span class="fc" id="L903">                electingFollowers.add(id);</span>
            }
<span class="fc" id="L905">            QuorumVerifier verifier = self.getQuorumVerifier();</span>
<span class="fc bfc" id="L906" title="All 4 branches covered.">            if (electingFollowers.contains(self.getId()) &amp;&amp; verifier.containsQuorum(electingFollowers)) {</span>
<span class="fc" id="L907">                electionFinished = true;</span>
<span class="fc" id="L908">                electingFollowers.notifyAll();</span>
            } else {                
<span class="fc" id="L910">                long start = System.currentTimeMillis();</span>
<span class="fc" id="L911">                long cur = start;</span>
<span class="fc" id="L912">                long end = start + self.getInitLimit()*self.getTickTime();</span>
<span class="fc bfc" id="L913" title="All 4 branches covered.">                while(!electionFinished &amp;&amp; cur &lt; end) {</span>
<span class="fc" id="L914">                    electingFollowers.wait(end - cur);</span>
<span class="fc" id="L915">                    cur = System.currentTimeMillis();</span>
                }
<span class="fc bfc" id="L917" title="All 2 branches covered.">                if (!electionFinished) {</span>
<span class="fc" id="L918">                    throw new InterruptedException(&quot;Timeout while waiting for epoch to be acked by quorum&quot;);</span>
                }
            }
<span class="fc" id="L921">        }</span>
<span class="fc" id="L922">    }</span>

    /**
     * Return a list of sid in set as string  
     */
    private String getSidSetString(Set&lt;Long&gt; sidSet) {
<span class="fc" id="L928">        StringBuilder sids = new StringBuilder();</span>
<span class="fc" id="L929">        Iterator&lt;Long&gt; iter = sidSet.iterator();</span>
<span class="pc bpc" id="L930" title="1 of 2 branches missed.">        while (iter.hasNext()) {</span>
<span class="fc" id="L931">            sids.append(iter.next());</span>
<span class="fc bfc" id="L932" title="All 2 branches covered.">            if (!iter.hasNext()) {</span>
<span class="fc" id="L933">              break;</span>
            }
<span class="fc" id="L935">            sids.append(&quot;,&quot;);</span>
        }
<span class="fc" id="L937">        return sids.toString();</span>
    }

    /**
     * Start up Leader ZooKeeper server and initialize zxid to the new epoch
     */
    private synchronized void startZkServer() {
        // Update lastCommitted and Db's zxid to a value representing the new epoch
<span class="fc" id="L945">        lastCommitted = zk.getZxid();</span>
<span class="fc" id="L946">        LOG.info(&quot;Have quorum of supporters, sids: [ &quot;</span>
<span class="fc" id="L947">                + getSidSetString(newLeaderProposal.ackSet)</span>
                + &quot; ]; starting up and setting last processed zxid: 0x{}&quot;,
<span class="fc" id="L949">                Long.toHexString(zk.getZxid()));</span>
<span class="fc" id="L950">        zk.startup();</span>
        /*
         * Update the election vote here to ensure that all members of the
         * ensemble report the same vote to new servers that start up and
         * send leader election notifications to the ensemble.
         * 
         * @see https://issues.apache.org/jira/browse/ZOOKEEPER-1732
         */
<span class="fc" id="L958">        self.updateElectionVote(getEpoch());</span>

<span class="fc" id="L960">        zk.getZKDatabase().setlastProcessedZxid(zk.getZxid());</span>
<span class="fc" id="L961">    }</span>

    /**
     * Process NEWLEADER ack of a given sid and wait until the leader receives
     * sufficient acks.
     *
     * @param sid
     * @param learnerType
     * @throws InterruptedException
     */
    public void waitForNewLeaderAck(long sid, long zxid, LearnerType learnerType)
            throws InterruptedException {

<span class="fc" id="L974">        synchronized (newLeaderProposal.ackSet) {</span>

<span class="fc bfc" id="L976" title="All 2 branches covered.">            if (quorumFormed) {</span>
<span class="fc" id="L977">                return;</span>
            }

<span class="fc" id="L980">            long currentZxid = newLeaderProposal.packet.getZxid();</span>
<span class="pc bpc" id="L981" title="1 of 2 branches missed.">            if (zxid != currentZxid) {</span>
<span class="nc" id="L982">                LOG.error(&quot;NEWLEADER ACK from sid: &quot; + sid</span>
                        + &quot; is from a different epoch - current 0x&quot;
<span class="nc" id="L984">                        + Long.toHexString(currentZxid) + &quot; receieved 0x&quot;</span>
<span class="nc" id="L985">                        + Long.toHexString(zxid));</span>
<span class="nc" id="L986">                return;</span>
            }

<span class="fc bfc" id="L989" title="All 2 branches covered.">            if (learnerType == LearnerType.PARTICIPANT) {</span>
<span class="fc" id="L990">                newLeaderProposal.ackSet.add(sid);</span>
            }

<span class="fc bfc" id="L993" title="All 2 branches covered.">            if (self.getQuorumVerifier().containsQuorum(</span>
                    newLeaderProposal.ackSet)) {
<span class="fc" id="L995">                quorumFormed = true;</span>
<span class="fc" id="L996">                newLeaderProposal.ackSet.notifyAll();</span>
            } else {
<span class="fc" id="L998">                long start = System.currentTimeMillis();</span>
<span class="fc" id="L999">                long cur = start;</span>
<span class="fc" id="L1000">                long end = start + self.getInitLimit() * self.getTickTime();</span>
<span class="pc bpc" id="L1001" title="1 of 4 branches missed.">                while (!quorumFormed &amp;&amp; cur &lt; end) {</span>
<span class="fc" id="L1002">                    newLeaderProposal.ackSet.wait(end - cur);</span>
<span class="fc" id="L1003">                    cur = System.currentTimeMillis();</span>
                }
<span class="pc bpc" id="L1005" title="1 of 2 branches missed.">                if (!quorumFormed) {</span>
<span class="nc" id="L1006">                    throw new InterruptedException(</span>
                            &quot;Timeout while waiting for NEWLEADER to be acked by quorum&quot;);
                }
            }
<span class="fc" id="L1010">        }</span>
<span class="fc" id="L1011">    }</span>

    /**
     * Get string representation of a given packet type
     * @param packetType
     * @return string representing the packet type
     */
    public static String getPacketType(int packetType) {
<span class="pc bpc" id="L1019" title="15 of 18 branches missed.">        switch (packetType) {</span>
        case DIFF:
<span class="fc" id="L1021">            return &quot;DIFF&quot;;</span>
        case TRUNC:
<span class="fc" id="L1023">            return &quot;TRUNC&quot;;</span>
        case SNAP:
<span class="fc" id="L1025">            return &quot;SNAP&quot;;</span>
        case OBSERVERINFO:
<span class="nc" id="L1027">            return &quot;OBSERVERINFO&quot;;</span>
        case NEWLEADER:
<span class="nc" id="L1029">            return &quot;NEWLEADER&quot;;</span>
        case FOLLOWERINFO:
<span class="nc" id="L1031">            return &quot;FOLLOWERINFO&quot;;</span>
        case UPTODATE:
<span class="nc" id="L1033">            return &quot;UPTODATE&quot;;</span>
        case LEADERINFO:
<span class="nc" id="L1035">            return &quot;LEADERINFO&quot;;</span>
        case ACKEPOCH:
<span class="nc" id="L1037">            return &quot;ACKEPOCH&quot;;</span>
        case REQUEST:
<span class="nc" id="L1039">            return &quot;REQUEST&quot;;</span>
        case PROPOSAL:
<span class="nc" id="L1041">            return &quot;PROPOSAL&quot;;</span>
        case ACK:
<span class="nc" id="L1043">            return &quot;ACK&quot;;</span>
        case COMMIT:
<span class="nc" id="L1045">            return &quot;COMMIT&quot;;</span>
        case PING:
<span class="nc" id="L1047">            return &quot;PING&quot;;</span>
        case REVALIDATE:
<span class="nc" id="L1049">            return &quot;REVALIDATE&quot;;</span>
        case SYNC:
<span class="nc" id="L1051">            return &quot;SYNC&quot;;</span>
        case INFORM:
<span class="nc" id="L1053">            return &quot;INFORM&quot;;</span>
        default:
<span class="nc" id="L1055">            return &quot;UNKNOWN&quot;;</span>
        }
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>